

Ref_ls = 'PROPANE'; %R290
%Ref_hs = 'CO2butaneMIX5050.mix'; %R744 and %R600
Ref_hs = 'CO2butane0595mass.mix'; %R744 and %R600
%Ref_hs = 'BUTANE';

Q_c = 250;

%compressor
eta_is = @(Pr_rat) -0.00000461*Pr_rat^6+0.00027131*Pr_rat^5-0.00628605...
    *Pr_rat^4+0.07370258*Pr_rat^3-0.46054399...
    *Pr_rat^2+1.40653347*Pr_rat-0.87811477;
eta_vol = @(Pr_rat) 0.0011*Pr_rat^2-0.0487*Pr_rat+0.9979;

%Internal heat exchangers
T_sh_ls = 5; %K
T_sh_hs = 5; %K
% T_sc_ls = 5;
% T_sc_hs = 5;
U_ihx_ls = 1400; %W/m^2K
U_ihx_hs = 1400; %W/m^2K

%Evaporator 
T_cw_in = 45+273.15; %K Cold water in
T_cw_out = 40+273.15; %K Cold water out
T_e = 35+273.15; %K Evaporating temp
U_e = 1600; %W/m^2K 
theta_e_in = T_cw_in-T_e; 
theta_e_out = T_cw_out-T_e; 
LMTD_e = (theta_e_in-theta_e_out)/(log(theta_e_in/theta_e_out));

%state properties
T_1 = T_e;
x_1 = 1;
h_1 = refpropm('H', 'T', T_1, 'Q', x_1, Ref_ls);%J/kg
h_ammonia = refpropm('H', 'T', T_1, 'Q', x_1, 'Ammonia');
P_1 = refpropm('P', 'T', T_1, 'Q', x_1, Ref_ls); %kPa
s_1 = refpropm('S', 'T', T_1, 'Q', x_1, Ref_ls); %J/kgK
rho_1 = refpropm('D', 'T', T_1, 'Q', x_1, Ref_ls); %kg/m^3

T_2 = T_1+T_sh_ls; %K
P_2 = P_1; %kPa
h_2 = refpropm('H', 'T', T_2, 'P', P_1, Ref_ls); %J/kg
s_2 = refpropm('S', 'T', T_2, 'H', h_2, Ref_ls); %J/kgK
rho_2 = refpropm('D', 'T', T_2, 'H', h_2, Ref_ls);

T_4 = 67+273.15;

P_3 = refpropm('P', 'T', T_4, 'Q', 0, Ref_ls); %kPa
h_3s = refpropm('H', 'P', P_3, 'S', s_2, Ref_ls); %J/kg
Pr_rat_ls = P_3/P_2;
comp_ls_is = eta_is(Pr_rat_ls);
h_3 = h_2+(h_3s-h_2)/comp_ls_is;
T_3 = refpropm('T', 'P', P_3, 'H', h_3, Ref_ls);
rho_3 = refpropm('D', 'T', T_3, 'S', s_2, Ref_ls); %kg/m^3
x_3 = refpropm('Q', 'T', T_3, 'H', h_3, Ref_ls); 

P_4 = P_3; 
h_4 = refpropm('H', 'T', T_4, 'Q', 0, Ref_ls);

P_5 = P_4; 
h_5 = h_1+h_4-h_2;
T_5 = refpropm('T', 'H', h_5, 'P', P_5, Ref_ls);

T_6 = T_1;
P_6 = P_1;
h_6 = h_5;

x_7 = 1;
T_7 = 60+273.15;
P_7 = refpropm('P', 'T', T_7, 'Q', x_7, Ref_hs); %kPa
h_7 = refpropm('H', 'T', T_7, 'Q', x_7, Ref_hs); %J/kg
s_7 = refpropm('S', 'T', T_7, 'Q', x_7, Ref_hs); %J/kgK
rho_7 = refpropm('D', 'T', T_7, 'Q', x_7, Ref_hs); %kg/m^3

T_8 = T_7+T_sh_hs;
P_8 = P_7;
h_8 = refpropm('H', 'T', T_8, 'P', P_8, Ref_hs);
s_8 = refpropm('S', 'T', T_8, 'H', h_8, Ref_hs);
rho_8 = refpropm('D', 'T', T_8, 'H', h_8, Ref_hs);
 
P_9 = 1800; %kPa
h_9s = refpropm('H', 'P', P_9, 'S', s_8, Ref_hs); %J/kg
%P_9 = refpropm('P', 'T', T_9, 'H', h_9s, Ref_hs); %kPa
Pr_rat_hs = P_9/P_8;
comp_hs_is = eta_is(Pr_rat_hs);
h_9 = h_8+(h_9s-h_8)/comp_hs_is; %%%
T_9 = refpropm('T', 'H', h_9, 'P', P_9, Ref_hs);
x_9 = refpropm('Q', 'T', T_9, 'H', h_9, Ref_hs);
s_9 = refpropm('S', 'T', T_9, 'H', h_9, Ref_hs); %kJ/kgK

T_10 = refpropm('T', 'P', P_9, 'Q', 0, Ref_hs);
T_c_out = T_10;
P_10 = P_9;
h_10 = refpropm('H', 'T', T_10, 'Q', 0, Ref_hs); %J/kg

P_11 = P_10;
h_11 = h_7+h_10-h_8;
T_11 = refpropm('T', 'H', h_11, 'P', P_11, Ref_hs);

P_12 = P_7; 
h_12 = h_11;
T_12 = refpropm('T', 'H', h_12, 'P', P_12, Ref_hs);
T_rhs_in = T_12;


m_rhs = 1000*Q_c/(h_9-h_10); %kg/s
Q_hs = m_rhs*(h_7-h_12)/1000; %kW
m_rls = Q_hs*1000/(h_3-h_4); %kg/s
Q_ls = m_rls*(h_3-h_4)/1000; %kW
Q_e = m_rls*(h_1-h_6)/1000; %kJ/kg

%Cascade heat exchanger
T_rhs_in = T_12;
T_rhs_out = T_7;
T_rls = T_4;
theta_cas_in = T_rls-T_rhs_in; 
theta_cas_out = T_rls-T_rhs_out; 
U_cas = 1800; %W/m^2K
LMTD_cas = (theta_cas_in-theta_cas_out)/(log(theta_cas_in/theta_cas_out));


%Condenser 
T_hw_in = 60+273.15; %K
T_hw_out = 100+273.15; %K
%T_c_in = 120+273.15; %K
%T_c_in = refpropm('T', 'P', 6900, 'Q', 1, Ref_hs); %K
%T_c_out = refpropm('T', 'P', 6900, 'Q', 0, Ref_hs); %K
U_c = 1400; %W/m^2K
% theta_c_in = T_c_in-T_hw_out;
% theta_c_out = T_c_out-T_hw_in; 
% LMTD_c = (theta_c_in-theta_c_out)/(log(theta_c_in/theta_c_out));

dT_lmtd_c = zeros(1, 10);
T_hw = linspace(100+273.15, 60+273.15, 11);
T_c = zeros(1, 11);
Area_c = zeros(1, 10);
h_c = zeros(1, 11);
Q_cond = zeros(1, 10);
inc = (h_9-h_10)/10;
T_c(1) = refpropm('T', 'P', P_9, 'H', h_9, Ref_hs);
T_c_in = T_c(1);
h_c(1) = h_9;

%T_c(end) = refpropm('T', 'P', P, 'H', h_9, Ref_hs);
for i = 2:11
    h_c(i) = h_9 - (i-1)*inc;
    T_c(i) = refpropm('T', 'P', P_9, 'H', h_c(i), Ref_hs);
    dT_lmtd_c(i-1) = (T_c(i-1)-T_hw(i-1)+T_hw(i)-T_c(i))/...
        (log((T_c(i-1)-T_hw(i-1))/(T_c(i)-T_hw(i))));
    Area_c(i-1) = (h_c(i-1)-h_c(i))*m_rhs/(dT_lmtd_c(i-1)*U_c);
    Q_cond(i-1) = dT_lmtd_c(i-1)*Area_c(i-1)*U_c/1000;
end

% %internal heat exchangers
T_sc_ls = T_4-T_5;
T_sc_hs = T_10-T_11;
theta_in_ls = T_5-T_1;
theta_out_ls = T_4-T_2;
theta_in_hs = T_11-T_7;
theta_out_hs = T_10-T_8;
LMTD_ihx_hs = (theta_in_hs-theta_out_hs)...
    /log((theta_in_hs/theta_out_hs));
LMTD_ihx_ls = (theta_in_ls-theta_out_ls)...
    /(log(theta_in_ls/theta_out_ls));
A_ihx_ls = (h_2-h_1)*m_rls/(LMTD_ihx_ls*U_ihx_ls);
A_ihx_hs = (h_8-h_7)*m_rhs/(LMTD_ihx_hs*U_ihx_hs);

%water properties
h_cw_in = refpropm('H', 'T', T_cw_in, 'Q', 0, 'water'); %J/kg
h_cw_out = refpropm('H', 'T', T_cw_out, 'Q', 0, 'water');%J/kg
h_hw_in = refpropm('H', 'T', T_hw_in, 'Q', 0, 'water'); %J/kg
h_hw_out = refpropm('H', 'T', T_hw_out, 'Q', 0, 'water'); %J/kg
dh_cw = h_cw_in-h_cw_out; %J/kg
dh_hw = h_hw_out-h_hw_in; %J/kg

m_cw = Q_e/(dh_cw/1000); %kg/s
m_hw = Q_c/(dh_hw/1000); %kg/s

W_comp_hs = m_rhs*(h_9-h_8)/1000; %kW %%%
W_comp_ls = m_rls*(h_3-h_2)/1000; %kW %%%
W_comp_tot = W_comp_hs+W_comp_ls;
COP = Q_c/W_comp_tot; 
comp_ls_vol = eta_vol(P_3/P_2); %%%
comp_hs_vol = eta_vol(P_9/P_8); %%%
comp_size_ls = m_rls*3600/(rho_2*comp_ls_vol);%m^3/h %%%
comp_size_hs = m_rhs*3600/(rho_8*comp_hs_vol);%m^3/h %%%

A_c = sum(Area_c); %(h_9-h_10)*m_rhs/(LMTD_c*U_c); %m^2
A_e = (h_1-h_6)*m_rls/(LMTD_e*U_e); %m^2
A_cas = (h_7-h_12)*m_rhs/(U_cas*LMTD_cas); %m^2
x = ['A_evap = ', num2str(A_e), ' m^2'];
y = ['A_cond = ', num2str(A_c), ' m^2'];
z = ['comp_size_ls = ', num2str(comp_size_ls), ' m^3/h'];
a = ['comp_size_hs = ', num2str(comp_size_hs), ' m^3/h'];
b = ['mass_ref_ls = ', num2str(m_rls), ' kg/s'];
c = ['mass_ref_hs = ', num2str(m_rhs), ' kg/s'];
d = ['A_cas = ', num2str(A_cas), ' m^2'];
e = ['COP = ', num2str(COP), ' [-]'];
f = ['A_ihx_hs = ', num2str(A_ihx_hs), ' m^2'];
g = ['A_ihx_ls = ', num2str(A_ihx_ls), ' m^2'];

disp(x);
disp(y);
disp(d);
disp(f);
disp(g);
disp(z);
disp(a);
disp(b);
disp(c);
disp(e);

